/* $Id: pstree.h,v 1.7 2000/01/06 23:58:20 ben Exp $ */
/*
 * Copyright (c) 2000 Ben Harris.  All rights reserved
 *
 * Redistribution and use in source and binary forms of parts of or the
 * whole original or derived work are permitted provided that the
 * original work is properly attributed to the author. The name of the
 * author may not be used to endorse or promote products derived from
 * this software without specific prior written permission. This work
 * is provided "as is" and without any express or implied warranties.
 */

#ifndef _PSTREE_H
#define _PSTREE_H

#include <sys/types.h>

extern void add_proc(char const *, pid_t, pid_t, uid_t, int,
		     char const * const *);
extern void add_proc_args(char const *, pid_t, pid_t, uid_t, char const *,
			  int);
extern int count_argv(char const * const *argv);
extern void read_proc_generic(char const *, void(*)(char const *));

extern int print_args;

#ifndef HAVE_ERR
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
extern void err (int, const char *, ...);
extern void verr (int, const char *, va_list);
extern void errx (int, const char *, ...);
extern void verrx (int, const char *, va_list);
extern void warn (const char *, ...);
extern void vwarn (const char *, va_list);
extern void warnx (const char *, ...);
extern void vwarnx (const char *, va_list);
#endif

extern void read_proc_svr4(void);
extern void read_proc_irix(void);
extern void read_proc_solaris(void);
extern void read_libproc(void);
extern void read_libps(void);

#endif

/*
 * Local variables:
 * c-file-style: "bsd"
 * End:
 */
