/* $Id: read_libproc.c,v 1.5 2000/01/06 22:16:11 ben Exp $ */
/*
 * Copyright (c) 2000 Ben Harris.  All rights reserved
 *
 * Redistribution and use in source and binary forms of parts of or the
 * whole original or derived work are permitted provided that the
 * original work is properly attributed to the author. The name of the
 * author may not be used to endorse or promote products derived from
 * this software without specific prior written permission. This work
 * is provided "as is" and without any express or implied warranties.
 */
/*
 * read_libproc.c - Read process data from Linux libproc
 */

#include "config.h"
#include <pstree.h>

#ifdef HAVE_ERR_H
#include <err.h>
#endif

#include <proc/readproc.h>

void read_libproc(void)
{
    PROCTAB *pt;
    proc_t* proc;

    if ((pt = openproc(print_args ? PROC_FILLCMD : 0)) == NULL)
	warn("openproc");
    else {
	while ((proc = readproc(pt, NULL)) != NULL) {
	    if (!print_args)
		add_proc(proc->cmd, proc->pid, proc->ppid, proc->uid, 0, NULL);
	    else
		add_proc(proc->cmd, proc->pid, proc->ppid, proc->uid,
			 count_argv((char const * const *)proc->cmdline),
			 (char const * const *)proc->cmdline);
	    freeproc(proc);
	}
	closeproc(pt);
    }
}

/*
 * Local variables:
 * c-file-style: "bsd"
 * End:
 */
