/* $Id: read_proc_svr4.c,v 1.2 2000/01/06 22:16:11 ben Exp $ */
/*
 * Copyright (c) 2000 Ben Harris.  All rights reserved
 *
 * Redistribution and use in source and binary forms of parts of or the
 * whole original or derived work are permitted provided that the
 * original work is properly attributed to the author. The name of the
 * author may not be used to endorse or promote products derived from
 * this software without specific prior written permission. This work
 * is provided "as is" and without any express or implied warranties.
 */
/*
 * read_proc_svr4.c - read process list for an SVR4-style /proc
 */

#include <config.h>
#include <pstree.h>

#include <sys/ioctl.h>
#include <sys/procfs.h>

#include <fcntl.h>
#include <string.h>
#include <unistd.h>

static void read_proc_entry_svr4(char const *name)
{
    int fd;
    struct prpsinfo psi;
    char *p;
    size_t argslen;

    /* see proc(4) */
    if ((fd = open(name, O_RDONLY)) >= 0) {
	if (ioctl(fd, PIOCPSINFO, &psi) != -1) {
	    argslen =  strlen(psi.pr_psargs) + 1;
	    p = psi.pr_psargs;
	    /* XXX: Nasty kludge */
	    while (p = strchr(p, ' '))
		*p++ = 0;
	    add_proc_args(psi.pr_fname, psi.pr_pid, psi.pr_ppid, psi.pr_uid,
			  psi.pr_psargs, argslen);
	}
	close(fd);
    }
}

void read_proc_svr4(void)
{

    read_proc_generic("/proc", &read_proc_entry_svr4); 
}    

void read_proc_irix(void)
{

    read_proc_generic("/proc/pinfo", &read_proc_entry_svr4); 
}

/*
 * Local variables:
 * c-file-style: "bsd"
 * End:
 */
